unit IconDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
type
  TIconExt = (ico,icl,dll,exe,allicon,allfile);
  TIconDlg = class(TComponent)
  private
   FFileName  : AnsiString;
   FIconIndex : Integer;
   FInitialDir: AnsiString;
   FTitle     : AnsiString;
   FDefaultExt: TIconExt;
  public
   function Execute : Boolean;
  published
   property DefaultExt : TIconExt   read FDefaultExt write FDefaultExt;
   property FileName   : AnsiString read FFileName   write FFileName;
   property IconIndex  : Integer    read FIconIndex  write FIconIndex;
   property InitialDir : AnsiString read FInitialDir write FInitialDir;
   property Title      : AnsiString read FTitle      write FTitle;
  end;
procedure Register;
implementation
{$R *.Res}
uses IconForm;
function TIconDlg.Execute : Boolean;
var Temp : TIconBox;
begin
     Temp := TIconBox.Create(Application);
     try
      Temp.OpenDialog1.InitialDir := FInitialDir;
      Temp.Edit1.Text  := FFileName;
      Temp.OpenDialog1.FilterIndex := integer(FDefaultExt);
      Temp.Caption := FTitle;
      if FileExists(FFileName) then
      Temp.LoadIcon(FFileName,FIconIndex);
      Temp.ShowModal;
      if Temp.ModalResult = idOK then
      begin
           FFileName  := Temp.Edit1.Text;
           FIconIndex := Temp.ListView1.Selected.Index;
           result := true;
      end else result := false;
     finally
      Temp.Free;
     end;
end;
procedure Register;
begin
  RegisterComponents('Dialogs', [TIconDlg]);
end;
end.
