unit IconForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls;
type
  TIconBox = class(TForm)
    ImageList1: TImageList;
    OKButton: TSpeedButton;
    CancelButton: TSpeedButton;
    BrowseButton: TSpeedButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    ListView1: TListView;
    procedure BrowseButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
  public
   Function LoadIcon(FileName : AnsiString;Index : Integer) : Boolean;
  end;
var IconBox : TIconBox;
implementation
uses ShellApi,CommCtrl;
{$R *.DFM}
Function TIconBox.LoadIcon(FileName : AnsiString;Index : Integer) : Boolean;
var MaxIcon,I : Integer;
    NewItem   : TListItem;
begin
     MaxIcon := ExtractIcon(HInstance,Pchar(FileName),-1);
     if MaxIcon > 0 then
     begin
          ImageList1.Clear;
          ListView1.Items.clear;
          for I := 0 to MaxIcon do
          ImageList_AddIcon(ImageList1.Handle,ExtractIcon(HInstance,PChar(FileName),I));
          for I := 0 to MaxIcon do
          begin
               NewItem := ListView1.Items.add;
               NewItem.ImageIndex := I;
          end;
          Edit1.Text := FileName;
          result := true;
          if (Index > -1) then
          ListView1.Items[Index].selected := true
          else if (MaxIcon = 1) then
          ListView1.Items[0].selected := true;
          OKButton.Enabled := ListView1.selcount > 0;
          if Active then ListView1.SetFocus;
     end else
     begin
          Result := false;
          OKButton.Enabled := false;
     end;
end;
procedure TIconBox.BrowseButtonClick(Sender: TObject);
begin
     if OpenDialog1.Execute then
     LoadIcon(OpenDialog1.FileName,-1);
end;
procedure TIconBox.CancelButtonClick(Sender: TObject);
begin
     ModalResult := idCancel;
end;
procedure TIconBox.ListView1Click(Sender: TObject);
begin
     if ListView1.SelCount > 0 then
     OKButton.Enabled := true;
end;

procedure TIconBox.OKButtonClick(Sender: TObject);
begin
     ModalResult := IDOK;
end;
end.
